﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ScanIP;

namespace SimpleFilterBox
{
    class ThinObjectSmoother : Command
    {
        Doc doc;
        int Dilate;
        double Smooth;
        int Erode;

        public ThinObjectSmoother(int dilate, double smooth, int erode) : base()
        {
            doc = App.GetDocument();
            Dilate = dilate;
            Smooth = smooth;
            Erode = erode;
        }

        // Strictly we should wrap this in some try-catch incase something goes wrong.
        public override bool Do()
        {
            doc.ApplyDilateFilter(Doc.FilterTarget.TargetMask, Dilate, 0);
            doc.ApplyRecursiveGaussianFilter(Doc.FilterTarget.TargetMask, true, new Sigma(Smooth));
            doc.ApplyErodeFilter(Doc.FilterTarget.TargetMask, Erode, 0);
            return true;
        }

        public override string GetName()
        {
            return "Thin object smooth";
        }

        public override void OnNativeDelete()
        {
            doc.ReleaseCommand(this);
        }
    }
}
